
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Stock_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_items = await db.stock_items.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        category: data.category
        ||
        null
            ,
            
        unit: data.unit
        ||
        null
            ,
            
        quantity_on_hand: data.quantity_on_hand
        ||
        null
            ,
            
        reorder_threshold: data.reorder_threshold
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await stock_items.setStock_location( data.stock_location || null, {
            transaction,
        });
        

        

        

        return stock_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const stock_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                category: item.category
            ||
            null
            ,
            
                unit: item.unit
            ||
            null
            ,
            
                quantity_on_hand: item.quantity_on_hand
            ||
            null
            ,
            
                reorder_threshold: item.reorder_threshold
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const stock_items = await db.stock_items.bulkCreate(stock_itemsData, { transaction });

        // For each item created, replace relation files
        

        return stock_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const stock_items = await db.stock_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.category !== undefined) updatePayload.category = data.category;
        
        
        if (data.unit !== undefined) updatePayload.unit = data.unit;
        
        
        if (data.quantity_on_hand !== undefined) updatePayload.quantity_on_hand = data.quantity_on_hand;
        
        
        if (data.reorder_threshold !== undefined) updatePayload.reorder_threshold = data.reorder_threshold;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await stock_items.update(updatePayload, {transaction});

        
        
        if (data.stock_location !== undefined) {
            await stock_items.setStock_location(
              
              data.stock_location,
              
              { transaction }
            );
        }
        

        
        

        

        return stock_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_items = await db.stock_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of stock_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of stock_items) {
                await record.destroy({transaction});
            }
        });


        return stock_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const stock_items = await db.stock_items.findByPk(id, options);

        await stock_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await stock_items.destroy({
            transaction
        });

        return stock_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const stock_items = await db.stock_items.findOne(
            { where },
            { transaction },
        );

        if (!stock_items) {
            return stock_items;
        }

        const output = stock_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.stock_movements_stock_item = await stock_items.getStock_movements_stock_item({
            transaction
        });
        
        
        
        
        
        output.stock_location = await stock_items.getStock_location({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.stock_locations,
        as: 'stock_location',
        
        where: filter.stock_location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.stock_location.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.stock_location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stock_items',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.unit) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stock_items',
                        'unit',
                        filter.unit,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stock_items',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.quantity_on_handRange) {
                const [start, end] = filter.quantity_on_handRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_on_hand: {
                    ...where.quantity_on_hand,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_on_hand: {
                    ...where.quantity_on_hand,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reorder_thresholdRange) {
                const [start, end] = filter.reorder_thresholdRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reorder_threshold: {
                    ...where.reorder_threshold,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reorder_threshold: {
                    ...where.reorder_threshold,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.category) {
                where = {
                    ...where,
                category: filter.category,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.stock_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'stock_items',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.stock_items.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

